public class GSort{
	
	private static void swap(Comparable[] a, int i, int j){
		Comparable temp = a[i];
		a[i] = a[j];
		a[j] = temp;
	}
  
  private static boolean isSorted(Comparable[] a, int lo, int hi){
		for (int k= lo; k<hi; k++) if (0 < a[k].compareTo(a[k+1])) return false;
		return true;
	}

  private static boolean isSorted(Comparable[] a){
		return isSorted(a, 0, a.length-1);
	}

  private static Character[] stringToChr(String s){
		int l = s.length();
		Character[] res = new Character[l];
		for (int index = 0; index < l; index++)res[index] = s.charAt(index);
		return res;
	}
	
	private static String chrToString(Character[] ch){
		StringBuilder sb = new StringBuilder();
		for (Character c : ch) sb.append(c);
		return sb.toString();
	}
	
	public static void selectionSort(Comparable[] a){
		int l = a.length;
		for (int j=0; j<l-1; j++){
			int minIndex = j;
			for (int k=minIndex+1; k<l; k++)
			  if (a[k].compareTo(a[minIndex]) < 1) minIndex = k;
			swap(a,minIndex,j);
		}  
	}

public static void main(String ... args) {
     String sortBeispiel = "SORTIERBEISPIEL";
     Character [] sortFeld = stringToChr(sortBeispiel);
     System.out.println(isSorted(sortFeld));
     System.out.println(chrToString(sortFeld));
     selectionSort(sortFeld);
     System.out.println(chrToString(sortFeld));
     System.out.println(isSorted(sortFeld));
    }

}