#include "sortlib.h" 
#include "stoppuhr.h" 
#include <iostream.h> 

const int max = 1200000;        // maximaler Index von A	 
typedef int intA[max+1];   // A[0] .. A[max]
intA A,B;
double Laufzeit;

void main () 
{
cout.precision(8);
StoppUhrInit();
cout << "Sort-Tester: Anfang." << endl;
InitIntAr(B, max);

cout << endl << "Kopiere B -> A" << endl;
CopyIntAr(B, A, max);
// Achtung Laufzeit fr Insertion Sort wird ab 5000 zu gro
int insmax = ( max > 5000 ? 5000 : max );
if ( !TestAr(A,insmax) )  cout << "Teste-A: A ist noch nicht sortiert! " << endl;
cout << "Insertion-Sort des Array A. Elemente: " << insmax << endl;
StoppUhrStart();
InsertionSort(A,insmax);
StoppUhrStopp();
Laufzeit = StoppUhrLies();
if ( TestAr(A,insmax) )  cout << "Teste-A: ok - A ist jetzt sortiert! " << endl;
else        cout << "Teste-A: Fehler - A ist nicht sortiert!!! " << endl;
cout << "Laufzeit: " << Laufzeit << endl;

cout << endl << "Kopiere B -> A" << endl;
CopyIntAr(B, A, max);
if ( !TestAr(A,max) )  cout << "Teste-A: A ist noch nicht sortiert! " << endl;
cout << "Shell-Sort des Array A. Elemente: " << max  << endl;
StoppUhrStart();
ShellSort(A,max);
StoppUhrStopp();
Laufzeit = StoppUhrLies();
if ( TestAr(A,max) )  cout << "Teste-A: ok - A ist jetzt sortiert! " << endl;
else        cout << "Teste-A: Fehler - A ist nicht sortiert!!! " << endl;
cout << "Laufzeit: " << Laufzeit << endl;

cout << endl << "Kopiere B -> A" << endl;
CopyIntAr(B, A, max);
if ( !TestAr(A,max) )  cout << "Teste-A: A ist noch nicht sortiert! " << endl;
cout << "Distribution-Sort des Array A. Elemente: " << max  << endl;
StoppUhrStart();
  
DistributionSort(A,max);
StoppUhrStopp();
Laufzeit = StoppUhrLies();
if ( TestAr(A,max) )  cout << "Teste-A: ok - A ist jetzt sortiert! " << endl;
else        cout << "Teste-A: Fehler - A ist nicht sortiert!!! " << endl;
cout << "Laufzeit: " << Laufzeit << endl;
 

cout << "Sort-Tester: fertig." << endl;

cin.get( );
}
